﻿//The ScenarioObj used by Fleet.fla

class ScenarioObj{
	/* Variables */
	var name:String;	//the name of this scenario
	var root:MovieClip;	//a pointer to the _root MovieClip object in the timeline that created this ScenarioObj
	var savedPathwaysArray:Array; //array of SavedPathwayObj objects (and corresponding inputs)
	//variables storing the 'Other Inputs' area inputs.
	var totalStockInitYearInput:String;
	var totalStockInitValueInput:String;
	var totalStockGrowthRateInput:String;
	var totalStock2005Input:String;
	var totalStock2010Input:String;
	var totalStock2015Input:String;
	var totalStock2020Input:String;
	var totalStock2025Input:String;
	var totalStock2030Input:String;
	var VMTPerVehicleInitYearInput:String;
	var VMTPerVehicleInitValueInput:String;
	var VMTPerVehicleGrowthRateInput:String;
	var VMTPerVehicle2005Input:String;
	var VMTPerVehicle2010Input:String;
	var VMTPerVehicle2015Input:String;
	var VMTPerVehicle2020Input:String;
	var VMTPerVehicle2025Input:String;
	var VMTPerVehicle2030Input:String;
	var baselineMPGInitYearInput:String;
	var baselineMPGInitValueInput:String;
	var baselineMPGGrowthRateInput:String;
	var baselineMPG2005Input:String;
	var baselineMPG2010Input:String;
	var baselineMPG2015Input:String;
	var baselineMPG2020Input:String;
	var baselineMPG2025Input:String;
	var baselineMPG2030Input:String;
	var totalStockIsManual:Boolean;
	var VMTPerVehicleIsManual:Boolean;
	var baselineMPGIsManual:Boolean;
	//variables storing the 'Weighted Results' tab inputs	
	var petrolEnergyWeightInput:String;
	var fossilEnergyWeightInput:String;
	var otherEnergyWeightInput:String;
	var GHGEmissionsWeightInput:String;
	var isRelativeChange:Boolean;
	var isNormalized:Boolean;
	//arrays storing the total results for this scenario (used in scenario comparisons)
	var LDVResults:Array;
	var VMTResults:Array;
	var VMTCumulativeResults:Array;
	var petrolResults:Array;
	var petrolCumulativeResults:Array;
	var fossilResults:Array;
	var fossilCumulativeResults:Array;
	var GHGResults:Array;
	var GHGCumulativeResults:Array;
	var weightedResults:Array;
	var weightedCumulativeResults:Array;
	
	/*
	// Constructor.
	// Arguments: n:String    	the name of this scenario
				  r:MovieClip 	pointer to the _root MovieClip object in the timeline that created this ScenarioObj
				  p:Array		array of PathwayObj objects (and corresponding inputs)
    */
	function ScenarioObj(n:String, r:MovieClip, p:Array){
		name = n;
		root = r;
		
		saveScenario(p);
		
trace("(ScenarioObj.constructor.59)  New scenario: " + petrolEnergyWeightInput + " " + fossilEnergyWeightInput + " " + otherEnergyWeightInput + " " + GHGEmissionsWeightInput);
	}	//end constructor
	
	/*
	// Arguments: pathways:Array		array of PathwayObj objects (and corresponding inputs)
    */
	function saveScenario(pathways:Array){
		
		//variables storing the 'Other Inputs' area inputs.
		totalStockInitYearInput = root.totalStockInitYearInput;
		totalStockInitValueInput = root.totalStockInitValueInput;
		totalStockGrowthRateInput = root.totalStockGrowthRateInput;
		totalStock2005Input = root.totalStock2005Input;
		totalStock2010Input = root.totalStock2010Input;
		totalStock2015Input = root.totalStock2015Input;
		totalStock2020Input = root.totalStock2020Input;
		totalStock2025Input = root.totalStock2025Input;
		totalStock2030Input = root.totalStock2030Input;
		VMTPerVehicleInitYearInput = root.VMTPerVehicleInitYearInput;
		VMTPerVehicleInitValueInput = root.VMTPerVehicleInitValueInput;
		VMTPerVehicleGrowthRateInput = root.VMTPerVehicleGrowthRateInput;
		VMTPerVehicle2005Input = root.VMTPerVehicle2005Input;
		VMTPerVehicle2010Input = root.VMTPerVehicle2010Input;
		VMTPerVehicle2015Input = root.VMTPerVehicle2015Input;
		VMTPerVehicle2020Input = root.VMTPerVehicle2020Input;
		VMTPerVehicle2025Input = root.VMTPerVehicle2025Input;
		VMTPerVehicle2030Input = root.VMTPerVehicle2030Input;
		baselineMPGInitYearInput = root.baselineMPGInitYearInput;
		baselineMPGInitValueInput = root.baselineMPGInitValueInput;
		baselineMPGGrowthRateInput = root.baselineMPGGrowthRateInput;
		baselineMPG2005Input = root.baselineMPG2005Input;
		baselineMPG2010Input = root.baselineMPG2010Input;
		baselineMPG2015Input = root.baselineMPG2015Input;
		baselineMPG2020Input = root.baselineMPG2020Input;
		baselineMPG2025Input = root.baselineMPG2025Input;
		baselineMPG2030Input = root.baselineMPG2030Input;
		totalStockIsManual = root.totalStockIsManual;
	 	VMTPerVehicleIsManual = root.VMTPerVehicleIsManual;
	 	baselineMPGIsManual = root.baselineMPGIsManual;
		//variables storing the 'Weighted Results' tab inputs	
		petrolEnergyWeightInput = root.petrolEnergyWeightInput;
		fossilEnergyWeightInput = root.fossilEnergyWeightInput;
		otherEnergyWeightInput = root.otherEnergyWeightInput;
		GHGEmissionsWeightInput = root.GHGEmissionsWeightInput;
		isRelativeChange = root.isRelativeChange;
		isNormalized = root.isNormalized;
		//copy pathways array
		//this.savedPathwaysArray = pathways;
		this.savedPathwaysArray = new Array(pathways.length);
		for(var i:Number = 0; i < pathways.length; i++){
			this.savedPathwaysArray[i] = new SavedPathwayObj(pathways[i]);
		}
		//save total results arrays
		var temp:Array;
		temp = root.calcLDV(false, true);
//NOTE: this does a lot of repeat calcuations of calcLDV and calcVMT that could be avoided by writing a new 'saveResults' method within Model Calculations...
		LDVResults = temp[temp.length - 2];	//total results is stored in second to last array in two-dimensional array returned by calcLDV etc. (see code for FLEET.fla 'Model Calculations' layer)
		temp = root.calcVMT(false, true, false);
		VMTResults = temp[temp.length - 2];
		temp = root.calcVMT(false, true, true);
		VMTCumulativeResults = temp[temp.length-2];
trace("\nSAVING VMT CUMULATIVE RESULTS: [3] = " + VMTCumulativeResults[3]+"\n");
		temp = root.calcResults("Petrol", false, true, false);
		petrolResults = temp[temp.length - 2];
		temp = root.calcResults("Petrol", false, true, true);
		petrolCumulativeResults = temp[temp.length - 2];
		temp = root.calcResults("Fossil", false, true, false);
		fossilResults = temp[temp.length - 2];
		temp = root.calcResults("Fossil", false, true, true);
		fossilCumulativeResults = temp[temp.length - 2];
		temp = root.calcResults("GHGs", false, true, false);
		GHGResults = temp[temp.length - 2];
		temp = root.calcResults("GHGs", false, true, true);
		GHGCumulativeResults = temp[temp.length - 2];
		temp = root.calcResults("Weighted", false, true, false);
		weightedResults = temp[temp.length - 2];
		temp = root.calcResults("Weighted", false, true, true);
		weightedCumulativeResults = temp[temp.length - 2];
	}

	
	/*
	// Arguments: pathways:Array		array of PathwayObj objects (and corresponding inputs)
    */
	function loadFromScenario(pathways:Array){
		
		//load variables storing the 'Other Inputs' area inputs.
		root.totalStockInitYearInput = totalStockInitYearInput;
		root.totalStockInitValueInput = totalStockInitValueInput;
		root.totalStockGrowthRateInput = totalStockGrowthRateInput;
		root.totalStock2005Input = totalStock2005Input;
		root.totalStock2010Input = totalStock2010Input;
		root.totalStock2015Input = totalStock2015Input;
		root.totalStock2020Input = totalStock2020Input;
		root.totalStock2025Input = totalStock2025Input;
		root.totalStock2030Input = totalStock2030Input;
		root.VMTPerVehicleInitYearInput = VMTPerVehicleInitYearInput
		root.VMTPerVehicleInitValueInput = VMTPerVehicleInitValueInput;
		root.VMTPerVehicleGrowthRateInput = VMTPerVehicleGrowthRateInput;
		root.VMTPerVehicle2005Input = VMTPerVehicle2005Input;
		root.VMTPerVehicle2010Input = VMTPerVehicle2010Input;
		root.VMTPerVehicle2015Input = VMTPerVehicle2015Input;
		root.VMTPerVehicle2020Input = VMTPerVehicle2020Input;
		root.VMTPerVehicle2025Input = VMTPerVehicle2025Input;
		root.VMTPerVehicle2030Input = VMTPerVehicle2030Input;
		root.baselineMPGInitYearInput = baselineMPGInitYearInput;
		root.baselineMPGInitValueInput = baselineMPGInitValueInput;
		root.baselineMPGGrowthRateInput = baselineMPGGrowthRateInput;
		root.baselineMPG2005Input = baselineMPG2005Input;
		root.baselineMPG2010Input = baselineMPG2010Input;
		root.baselineMPG2015Input = baselineMPG2015Input;
		root.baselineMPG2020Input = baselineMPG2020Input;
		root.baselineMPG2025Input = baselineMPG2025Input;
		root.baselineMPG2030Input = baselineMPG2030Input;
		root.totalStockIsManual = totalStockIsManual;
	 	root.VMTPerVehicleIsManual = VMTPerVehicleIsManual;
	 	root.baselineMPGIsManual = baselineMPGIsManual;
		//load variables storing the 'Weighted Results' tab inputs	
		root.petrolEnergyWeightInput = petrolEnergyWeightInput;
		root.fossilEnergyWeightInput = fossilEnergyWeightInput;
		root.otherEnergyWeightInput = otherEnergyWeightInput;
		root.GHGEmissionsWeightInput = GHGEmissionsWeightInput;
		root.isRelativeChange = isRelativeChange;
		root.pathways_scroll_area.content.isRelativeChange = isRelativeChange;
		root.isNormalized = isNormalized;
		root.pathways_scroll_area.content.isNormalized = isNormalized;
		
		root.setInputs();
		
		trace("\nLoading pathways array from saved scenario...");
//trace("(ScenarioObj.loadFromScenario.119)   saved Pathway at index 0: " + SavedPathwayObj(this.savedPathwaysArray[0]).abbrev + " - current active Pathway at index 0: " + 
//		PathwayObj(root.pathways_scroll_area.content.pathwaysArray[0]).abbrev);
		//load pathways from saved pathways array:
		  //remove current Pathway_mc clips from scene and empty pathwaysArray...
		root.pathways_scroll_area.content.removeAllPathways();
		  //load from saved scenario and add corresponding Pathway_mc clips to scene...
		for(var i:Number = 0; i < this.savedPathwaysArray.length; i++){
//trace("(ScenarioObj.loadFromScenario.126) Loading pathway object: " + SavedPathwayObj(this.savedPathwaysArray[i]).abbrev + " pathway area collapsed? " + SavedPathwayObj(this.savedPathwaysArray[i]).pathwayIsCollapsed);
			root.pathways_scroll_area.content.addPathway(SavedPathwayObj(this.savedPathwaysArray[i]));
		}
		root.pathways_scroll_area.content.updateWeights();
//trace("...after load...");
//trace("(ScenarioObj.loadFromScenario.130)   saved Pathway at index 0: " + SavedPathwayObj(this.savedPathwaysArray[0]).abbrev + " - current active Pathway at index 0: " + 
//			PathwayObj(root.pathways_scroll_area.content.pathwaysArray[0]).abbrev);
		
//trace("(ScenarioObj.loadFromScenario.179) End of loadFromScenario: " + SavedPathwayObj(this.savedPathwaysArray[i]).abbrev + " pathway area collapsed? " + SavedPathwayObj(this.savedPathwaysArray[i]).pathwayIsCollapsed);
	}
	
	function getSavedResults(whichResults:String, isCumulative:Boolean):Array{
		if(whichResults == "Stock"){
			if(isCumulative){ return LDVResults; }  //there's no difference between cumulative and regular LDV results - LDV stock results are all cumulative.
			else{ return LDVResults; }
		} else if (whichResults == "VMT"){
			if(isCumulative){ return VMTCumulativeResults; }
			else{ return VMTResults; }
		} else if (whichResults == "Petrol"){
			if(isCumulative){ return petrolCumulativeResults; }
			else{ return petrolResults; }
		} else if(whichResults == "Fossil"){
			if(isCumulative){ return fossilCumulativeResults; }
			else{ return fossilResults; }
		} else if(whichResults == "GHGs"){
			if(isCumulative){ return GHGCumulativeResults; }
			else{ return GHGResults; }
		} else if(whichResults == "Weighted"){
			if(isCumulative){ return weightedCumulativeResults; }
			else{ return weightedResults; }
		} else{
			trace("ERROR: Invalid parameter - 'whichResults' in ScenarioObj.as getSavedResults.211");
			return;
		}
	}
	
	//function t(){
	//	for(var i:Number = 0; i < savedPathwaysArray.length)
	//	trace("  -" + PathwayObj(savedPathwaysArray[0]).abbrev + " Petrol Energy: + " stock2030);
	//}
	
	
} //end class